LFR-FSW - Task #614

3.0.0.20
09/02/2016 05:05 PM - paul leroy

Status: Closed Start date: 09/02/2016
Priority: Normal Due date:

Assignee: thomas chust % Done: 0%
Category: Estimated time: 0.00 hour
Target version: Spent time: 0.00 hour
revision:

Description

J'ai trouvé un bug sur la resynchro des snapshots. Je propose de lancer le test NORMAL long sur cette version, j'aimerais voir le
résultat sur la période des shapshots, j'ai un peu changé la stratégie.
Le bug venait du fait que les corrections supérieures a 1 tick a f2 n'étaient pas correctement gérées.

e 3.0.0.20 *** 09 FEB 2016

_ fsw__ Changeset: 274 (4b39bb5ceb61)

snapshot resynchronisation modified, correction is multiplied by 2 when above 1
f2 tick

Bug #491 => modification of hk_Ifr_vhdl_aa_sm

snapshot resynchronisation updated following #612 task

Related issues:

Related to Task #615: Validation SWF 22s pour 3.0.0.20 Stalled 10/02/2016
Related to Bug #616: Long test in SBM1 and SBM2 modes Closed 10/02/2016
Related to Task #618: Long test with SBM1 and SBM2 FSW 3.0.0.20 Closed 11/02/2016
Related to Task #622: livraison srec 3.0.0.20 et 3.0.0.22 Closed 12/02/2016
Related to Task #630: Long Test in normal mode in 3.0.0.22 Closed 18/02/2016
History

#1 - 09/02/2016 05:21 PM - bruno katra

- Status changed from New to In Progress

Installation du software le 09/02/2016
dans /opt/LFR/LFR-FSW/3.0.0.20 + renommage de I'exe sans l'extension 3-0-0-20
Adaptation des scripts pour utiliser cette version.

#2 - 09/02/2016 05:22 PM - bruno katra

Lancement du tests long @ 17h18 : 14h40 de NORMAL avec TIMEGEN et tous les produis nominaux (SWF a 300s et ASM a 3600s).
FIN PREVUE le 10/02/2016 a 7h58.

#3 - 10/02/2016 08:18 AM - Veronique bouzid

- File test_modes.py added

- Assignee set to thomas chust

14h40 de NORMAL mode joués cette nuit. Les parametres utilisés sont ceux par défaut du normal mode. Le test s'est bien terminé

Premier test d'analyse sur les Snapshots a 300s et les CWF_F3 (vérifier si premiere salve de CWF_F3 correcte)

Les fichiers (2016_02_09_17_18_56*) sont pc-instru/weekly erased /Thomas/run-2016-02-09-3.0.0.20-1.1.89.

Les fichiers (2016_02_09_17_18_56*)sont rangés également sur pc-faust9 répertoire/ home/validation/data/R3/3.0.0.20/ TESTCHARGE/normal.

En piece jointe le script /opt/VALIDATION_R3/test_modes.py joué
https://hephaistos.lpp.polytechnique.fr/redmine/issues/491
https://hephaistos.lpp.polytechnique.fr/redmine/issues/612

Contexte du test

FSW 3.0.0.20

VHDL 1.1.89

Timegen 0.0.0.1

EM AVEC Timegen

SocExplorerEngine.getSocExplorer: Version = 0.6.2, Branch = default, Changeset = 819d0376d481
StarDundee

#4 - 10/02/2016 10:06 AM - thomas chust

- File plot_delta_ SWF_FO0_test.png added

- File plot_delta_ SWF_F1_test.png added

- File plot_delta_ SWF_F2_test.png added

- File tests_time_asm_VHDL-1.1.89_FSW-3.0.0.20_2016_02_09_test added
- File tests_time_cwf VHDL-1.1.89 FSW-3.0.0.20_2016_02_09 test added
- File tests_time_swf_VHDL-1.1.89_FSW-3.0.0.20_2016_02_09_test added

- Assignee changed from thomas chust to paul leroy

Tests faits sur les SWF montrent une nette amélioration par rapport au premier test long #612
La logique de resynchronisation semble de nouveau maitrisée mais les amplitudes des oscillations sont 2 a 3 fois supérieures par rapport aux
meilleurs tests précédents.

#5 - 10/02/2016 10:39 AM - Veronique bouzid
- Related to Task #615: Validation SWF 22s pour 3.0.0.20 added

#6 - 10/02/2016 02:17 PM - paul leroy
On va y arriver! Merci en tout cas pour les nombreux tests et validations effectués. Vous étes des pros!
Les oscillations sont plus importantes parce que la dérive est plus importante avec une période de 300s qu'avec 22s (toujours supérieure a plusieurs

T2 sur ma machine ici). Je vous joins le dessin que j'ai fait pour expliquer la resynchro dans la version 3.0.0.20. Le terme de correction est calculé
comme l'écart, positif ou négatif entre le centre du snapshot regu et la seconde exacte, ceci en float, I'unité étant T2:

switch (state)

{

case MEASURE:
// * Kk kkkkkk

PRINTF1 ("MEASURE === %d\n", nbSnapshots);

state = CORRECTION;

correction = computeCorrection( timePtr );

PRINTF1 ("MEASURE === correction = %.2f\n", correction );

applyCorrection( correction );

PRINTF1 ("MEASURE === delta_snapshot = %d\n", waveform_picker_regs->delta_snapshot);
//****

break;

case CORRECTION:
//************
PRINTF1 ("CORRECTION === %d\n", nbSnapshots);
state = MEASURE;
computeCorrection( timePtr );
set_wfp_delta_snapshot () ;

PRINTF1 ("CORRECTION === delta_snapshot = %d\n", waveform_picker_regs->delta_snapshot);
//****
break;
default:
break;

}
Une fois sur deux, on applique la valeur nominale de delta_snapshot et une fois sur deux la valeur de Ideta_snapshot corrigée de la dérive mesurée.
Avec la fonction qui applique la correction:
void applyCorrection( double correction )

{

int correctionInt;
}

if (correction >= 0.)

{

if ( (1. > correction) && (correction > 0.5) )
{
correctionInt = 1;
}
else
{
correctionInt = 2 * floor (correction);
}
}
else
{
if ( (correction < -1.) && (correction < -0.5) )
{
correctionInt = -1;
}
else
{
correctionInt = 2 * ceil (correction);

}
}

waveform_picker_regs->delta_snapshot = waveform_picker_regs->delta_snapshot + correctionInt;

delta_snapshot est un entier. Suivant les valeurs du terme de correction:
=> on applique 0 si 0.5 > correction > 0

=> on applique 1 si 1 > correction > 0.5

=> on applique 2*floor(correction) si correction > 1

Facile non?

#7 - 10/02/2016 02:22 PM - paul leroy

- File LFR - snapshot resynchronization Rev1.1.pdf added

#8 - 10/02/2016 02:25 PM - paul leroy

- Assignee changed from paul leroy to thomas chust

#9 - 10/02/2016 05:39 PM - bruno katra
- Related to Bug #616: Long test in SBM1 and SBM2 modes added

#10 - 11/02/2016 11:20 AM - thomas chust

- Assignee changed from thomas chust to paul leroy

Super Paul pour toutes ces explications et cela n'est pas de trop! smile.png Effectivement on avance mais j'ai encore des questions :

1. Sur ta figure, "delta_snapshot + 2 x correction" signifie t-il bien "delta_snapshot += correctionInt" (cf le code de applyCorrection) ? De sorte que
ce que tu appelles la valeur nominale de delta_snapshot est en fait sa valeur avant I'application d'une correction (le coup d'avant)? Ou de fait la
valeur nominale est la valeur initiale que tu nommes delta_f2 ? Cela est important car si la dérive est bien supérieure a T2 on sera toujours en
retard ou en avance (par manque d'adaptation a la situation courante puisque delta_f2 est fixé a I'avance). Aussi quand tu écris sur la figure " +
2 x correction" c'est dans le cas seulement ou "correctionInt” vaut cette valeur, non ?

Le fait que tu appliques "2 x correction" c'est bien parce que la prise en compte ne sera effective que dans 2 coups (2 dérives qui se seront
accumulées depuis la mesure de "correction")?

2.Dans le cas d'une correction négative il me semble que tu as codé une boulette : dans "( (correction < -1.) && (correction < -0.5) )" tu voulais

certainement écrire "( -1. < correction)”, non ? Jusqu'a présent nous avions des corrections positives a faire je crois (dérive négative) de sorte
que cette coquille n'aurait pas été détectée ...

3. dans le bloc CORRECTION, a quoi sert la ligne "computeCorrection( timePtr );" qui n'affecte aucune valeur ?
4. Une suggestion naive: remplacer floor par ceil dans le cas d'une correction positive et inversement ceil par floor dans le cas opposé ? As-tu déja

essayé? Dans mon intuition j'imagine que cela correspondrait a une correction plus efficace (i.e. qui nous ramene plus prés d'une sharp
seconde). Mais cela est peut-étre instable ...

Merci encore pour ton boulot!

#11 - 11/02/2016 11:42 AM - paul leroy
- File LFR - snapshot resynchronization Rev1.2.pdf added

- Assignee changed from paul leroy to thomas chust

J'ai mis a jour mon dessin (révision 1.2), ce n'était pas assez clair.
1.la valeur delta_f2 est utilisée une seule fois au démarrage pour décompter le temps jusqu'au départ du premier snapshot a f2. Ensuite, le
compteur est rechargé avec la valeur delta_snapshot_init (valeur nominale) ou delta_snapshot_init + correctionint. delta_snapshot_init est la
valeur nominale que devrait avoir delta_snapshot si il n'y avait pas de dérive. Effectivement, le x2 vient du fait que la dérive est double entre le
moment ou on utilise delta_snapshot_init et le moment ou on utilise la correction

2. tout a fait d'accord avec la remarque. Halala, c'est dur ce passage du code. Je fais le correction!

3. le bloc computeCorrection me sert juste a faire des printf indicatifs pour le debug, la valeur n'est pas utilisée

4. une suggestion intéressante mais j'ai effectivement eu des cas instables au cours du développement alors j'ai mis la solution avec l'intervalle
0.5-1 qui permet d'appliquer une correction un peu en avance, avant que la dérive ne soit supérieure a un T2

#12 - 11/02/2016 02:43 PM - Veronique bouzid
- Related to Task #618: Long test with SBM1 and SBM2 FSW 3.0.0.20 added

#13 - 12/02/2016 08:25 AM - thomas chust

- Assignee changed from thomas chust to paul leroy

Hello Paul, je suis en train d'analyser le dernier test long en date (#618), je vais a priori vous sortir des résultats tout a fait similaires a ceux d'ici. Par
contre je n'arrive pas vraiment encore a coller ton algorithme sur les courbes d'écart observées. Donc encore une question pour éclaircir ma
lanterne:

- comment fixes-tu la valeur nominale delta_snapshot_init ? Cette valeur ne change t-elle plus jamais ?

#14 - 12/02/2016 08:40 AM - paul leroy

- Assignee changed from paul leroy to thomas chust

On récupere le paramétre sy_lIfr_n_swf_p dans les paquets ou on prend la valeur par défaut (300s) puis j'applique la fonction suivante pour mettre a
jour le paramétre utilisé par le VHDH

void set_wfp_delta_snapshot ( void )
{
/** This function sets the delta_snapshot register of the waveform picker module.
*
The value is read from two (unsigned char) of the parameter_dump_packet structure:
- sy_lfr n_swf_pl[0]
* — sy_lfr n_swf_pl[l]

*

*/

*
*

unsigned int delta_snapshot;
unsigned int delta_snapshot_in_T2;

delta_snapshot = parameter_dump_packet.sy_lfr_n_swf p[0]*256
+ parameter_dump_packet.sy_lfr_n_swf_p[l];

delta_snapshot_in_T2 = delta_snapshot * 256;
waveform_picker_regs->delta_snapshot = delta_snapshot_in_T2 - 1; // max 4 bytes

#15 - 12/02/2016 01:39 PM - bruno katra

Bonjour a tous.
Nous venons de livrer le FSW 3.0.0.20 via l'issue JIRA dédiée :
https://jira-lesia.obspm.fr/browse/RPWSSS-197

Il'y a un résumé des nouvelles modifications et fonctionnalités dans le commentaire du JIRA.

Cette version a été validée de fagon intensive et quasi exhaustive (tests des nouveautés + beaucoup de non-regression).

Cependant nous avons eu ce matin une nouvelle livraison de 3.0.0.22 qui est en cours de validation. Elle corrige un pb au niveau de la resynchro des
SWF mais c'est un bug mineur a priori pas facilement reproductible en test.

Par souci de fiabilité et afin de ne pas vous retarder plus : nous avons préféré vous livrer la version la mieux validée (3.0.0.20) mais nous vous
livrerons la 3.0.0.22 la semaine prochaine une fois qu'elle aura le méme niveau de validation que celle d'aujourd'hui. Cela vous laisse le choix selon
qu' un aménagement de votre planning le permet ou non de démarrer vos tests quand vous le souhaiterez.

Merci une fois encore a tous de votre compréhension sur les délais imprévus que nous avons eu mais soyez slrs que cela en valait la peine | La
marche entre 3.0.0.10 livré en octobre et la livraison d'aujourd'hui est conséquente.

Bonne fin de journée

Bruno

#16 - 12/02/2016 01:39 PM - bruno katra
- Related to Task #622: livraison srec 3.0.0.20 et 3.0.0.22 added
#17 - 13/02/2016 03:27 PM - Veronique bouzid
- Category set to SRS

#18 - 18/02/2016 10:47 AM - thomas chust
- Related to Task #630: Long Test in normal mode in 3.0.0.22 added

#19 - 02/03/2016 02:47 PM - bruno katra
- Category deleted (SRS)

- Status changed from In Progress to Closed

Files

README 18 KB 09/02/2016 paul leroy
fsw-3-0-0-20 4.06 MB 09/02/2016 paul leroy
test_modes.py 2.88 KB 10/02/2016 Veronique bouzid
plot_delta_ SWF_FO0_test.png 245 KB 10/02/2016 thomas chust
plot_delta SWF_F1_test.png 241 KB 10/02/2016 thomas chust
plot_delta SWF_F2_test.png 243 KB 10/02/2016 thomas chust
tests_time_asm_VHDL-1.1.89_FSW-3.0.0.20_2016_02_09 test 38 KB 10/02/2016 thomas chust
tests_time_cwf_VHDL-1.1.89_FSW-3.0.0.20_2016_02_09_test 37.7 KB 10/02/2016 thomas chust
